/*
* Copyright 2005 Sun Microsystems, Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* - Redistributions of source code must retain the above copyright
*   notice, this list of conditions and the following disclaimer.
*
* - Redistribution in binary form must reproduce the above copyright
*   notice, this list of conditions and the following disclaimer in
*   the documentation and/or other materials provided with the
*   distribution.
*
* Neither the name of Sun Microsystems, Inc. or the names of
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* This software is provided "AS IS," without a warranty of any
* kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
* WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
* EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES
* SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
* DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN
* OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR
* FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR
* PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF
* LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE,
* EVEN IF SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*
* You acknowledge that Software is not designed, licensed or intended
* for use in the design, construction, operation or maintenance of
* any nuclear facility.
*/

package com.sun.j2ee.blueprints.airlinesupplier.purchaseorder.ejb;

import javax.ejb.*;
import java.util.*;

import com.sun.j2ee.blueprints.airlinesupplier.powebservice.*;

/**
 * Implementation class for the  AirlineOrderBean .
 */
public abstract class AirlineOrderBean implements EntityBean {

    private EntityContext entityContext = null;

    public String ejbCreate(AirlineOrder flightObj) throws CreateException {

  setOrderId(flightObj.getOrderId());
  setDepFlightId(flightObj.getDepFlightId());
  setDepFlightDate(flightObj.getDepFlightDate().getTimeInMillis());
  setRetFlightId(flightObj.getRetFlightId());
  setRetFlightDate(flightObj.getRetFlightDate().getTimeInMillis());
  setHeadCount(flightObj.getHeadCount());
  return null;
    }

    public void ejbPostCreate(AirlineOrder po) throws CreateException {}

    //getters and setters for CMP  fields
    public abstract void setOrderId(String orderId);
    public abstract void setDepFlightId(String flightId);
    public abstract void setDepFlightDate(long date);
    public abstract void setRetFlightId(String flightId);
    public abstract void setRetFlightDate(long date);
    public abstract void setHeadCount(int count);

    public abstract String getOrderId();
    public abstract String getDepFlightId();
    public abstract long getDepFlightDate();
    public abstract String getRetFlightId();
    public abstract long getRetFlightDate();
    public abstract int getHeadCount();

    public void ejbRemove() throws RemoveException {}

    public void ejbLoad() {}

    public void ejbStore() {}

    public void ejbActivate() {}

    public void ejbPassivate() {}

    public void unsetEntityContext() {
  this.entityContext = null;
    }

    public void setEntityContext(EntityContext entityContext) {
  this.entityContext = entityContext;
    }
}
