/*
* Copyright 2005 Sun Microsystems, Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* - Redistributions of source code must retain the above copyright
*   notice, this list of conditions and the following disclaimer.
*
* - Redistribution in binary form must reproduce the above copyright
*   notice, this list of conditions and the following disclaimer in
*   the documentation and/or other materials provided with the
*   distribution.
*
* Neither the name of Sun Microsystems, Inc. or the names of
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* This software is provided "AS IS," without a warranty of any
* kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
* WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
* EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES
* SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
* DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN
* OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR
* FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR
* PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF
* LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE,
* EVEN IF SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*
* You acknowledge that Software is not designed, licensed or intended
* for use in the design, construction, operation or maintenance of
* any nuclear facility.
*/

package com.sun.j2ee.blueprints.opc.webservicebroker.requestor;

import javax.xml.rpc.*;
import javax.naming.*;

import com.sun.j2ee.blueprints.opc.JNDINames;

public class LodgingSupplierClient implements WSClient {

    public String sendRequest(String xmlDoc) {
  String ret = null;
  try {
      InitialContext ic = new InitialContext();
      LodgingPurchaseOrderService svc = (LodgingPurchaseOrderService) 
    ic.lookup(JNDINames.LODGING_SERVICE_NAME);
      String endpointURI = (String)
    ic.lookup(JNDINames.LODGING_SERVICE_URL);
      LodgingPOIntf port=(LodgingPOIntf)svc.getPort(LodgingPOIntf.class);

      // Required here because the sample app built the stubs using
      // static WSDL
      ((Stub)port)._setProperty(Stub.ENDPOINT_ADDRESS_PROPERTY,
              endpointURI);
      ret = port.submitLodgingReservationDetails(xmlDoc);
  } catch(Exception ex) {
            /* 
             *  Advanced error handling will be done for a later release, with 
             * the broker placing an error message in the work flow manager
             * queue so that the work flow manager can again call the broker
             * to send the PO to the proper supplier
             */ 
            System.err.println(ex);
  }
  return ret;
    }
}
