/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB)
// Reference Implementation, v2.0-06/22/2005 01:29 PM(ryans)-EA2
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a>
// Any modifications to this file will be lost upon recompilation of the source
// schema.
// Generated on: 2005.09.05 at 07:05:33 PM MSD
//
package org.netbeans.modules.bpel.model.api;

/**
 * @author ads
 */
public interface CompositeActivity extends Activity {

    /**
     * Gets the value of the activity property. Objects of the
     * ExtendableActivity type could appear in this list.
     * 
     * @return array of activities.
     */
    ExtendableActivity[] getActivities();

    /**
     * @param i
     *            index in array.
     * @return child activity on i-th position.
     */
    ExtendableActivity getActivity( int i );

    /**
     * Set activity on ith place.
     * 
     * @param activity
     *            object for set.
     * @param i
     *            position for set.
     */
    void setActivity( ExtendableActivity activity, int i );

    /**
     * Removes child activity.
     * 
     * @param i
     *            position for remove.
     */
    void removeActivity( int i );

    /**
     * Insert child activtity on the ith place.
     * 
     * @param activity
     *            object for insert.
     * @param i
     *            position for insert.
     */
    void insertActivity( ExtendableActivity activity, int i );

    /**
     * Add activity to the end of list.
     * 
     * @param activity
     *            add object to this parent.
     */
    void addActivity( ExtendableActivity activity );

    /**
     * Size of child activities.
     * 
     * @return size of children.
     */
    int sizeOfActivities();

    /**
     * Set array of activities as new list of activities children.
     * 
     * @param activities
     *            array of activitty objects.
     */
    void setActivtities( ExtendableActivity[] activities );

}
