/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

/**
 *
 */
package org.netbeans.modules.bpel.model.api;

import org.netbeans.modules.bpel.model.api.events.VetoException;

/**
 * @author ads
 *         <p>
 *         Java class for documentation element declaration.
 *         <p>
 *         The following schema fragment specifies the expected content
 *         contained within this class.
 *
 * <pre>
 *   &lt;xsd:element name="documentation" type="tDocumentation"/>
 *   &lt;xsd:complexType name="tDocumentation" mixed="true">
 *       &lt;xsd:sequence>
 *           &lt;xsd:any processContents="lax" minOccurs="0" maxOccurs="unbounded"/>
 *       &lt;/xsd:sequence>
 *       &lt;xsd:attribute name="source" type="xsd:anyURI"/>
 *       &lt;xsd:attribute ref="xml:lang"/>
 *   &lt;/xsd:complexType>
 * </pre>
 */
public interface Documentation extends BpelContainer, ContentElement {

    String SOURCE = "source";       // NOI18N

    String LANGUAGE = "xml:lang";   //  NOI18N

    /**
     * @return "source" attribute value.
     */
    String getSource();

    /**
     * Set source attribute value to <code>uri</code>.
     * 
     * @param uri New "source" attribute value. 
     * @throws VetoException
     *             Will be thrown if uri is not acceptable as value here.
     */
    void setSource( String uri ) throws VetoException;
    
    /**
     * Removes source attribute.
     */
    void removeSource();

    /**
     * @return "xml:lang" attribute value.
     */
    String getLanguage();

    /**
     * Set "xml:lang" attribute value to <code>lang</code>.
     * 
     * @param lang New language value.
     * @throws VetoException ( @link VetoException ) will be thrown 
     * if new value is not acceptable here. 
     */
    void setLanguage( String lang ) throws VetoException;
    
    /**
     * Removes "xml:lang" attribute.
     */
    void removeLanguage();

}
