/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

/**
 *
 */
package org.netbeans.modules.bpel.model.api.events;

/**
 * This is adapter class. One may override methods that needed. All other
 * methods delegates call to notifyEvent that don't have any implementation. If
 * one don't want to distinguish events he may just override notifyEvent. Either
 * he can override some of public methods and don't override notifyEvent.
 *
 * @author ads
 */
public class ChangeEventListenerAdapter implements ChangeEventListener {

    /*
     * (non-Javadoc)
     *
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyPropertyRemoved(org.netbeans.modules.soa.model.bpel.api.events.PropertyRemoveEvent)
     */
    /** {@inheritDoc} */
    public void notifyPropertyRemoved( PropertyRemoveEvent event ) {
        notifyEvent(event);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyEntityInserted(org.netbeans.modules.soa.model.bpel.api.events.EntityInsertEvent)
     */
    /** {@inheritDoc} */
    public void notifyEntityInserted( EntityInsertEvent event ) {
        notifyEvent(event);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyPropertyUpdated(org.netbeans.modules.soa.model.bpel.api.events.PropertyUpdateEvent)
     */
    /** {@inheritDoc} */
    public void notifyPropertyUpdated( PropertyUpdateEvent event ) {
        notifyEvent(event);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyEntityRemoved(org.netbeans.modules.soa.model.bpel.api.events.EntityRemoveEvent)
     */
    /** {@inheritDoc} */
    public void notifyEntityRemoved( EntityRemoveEvent event ) {
        notifyEvent(event);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyEntityUpdated(org.netbeans.modules.soa.model.bpel.api.events.EntityUpdateEvent)
     */
    /** {@inheritDoc} */
    public void notifyEntityUpdated( EntityUpdateEvent event ) {
        notifyEvent(event);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.netbeans.modules.soa.model.bpel.api.events.ChangeEventListener#notifyArrayUpdated(org.netbeans.modules.soa.model.bpel.api.events.ArrayUpdateEvent)
     */
    /** {@inheritDoc} */
    public void notifyArrayUpdated( ArrayUpdateEvent event ) {
        notifyEvent(event);
    }

    /**
     * This is method that is used for delegation from each listener methods.
     * 
     * @param event
     *            notification event.
     */
    protected void notifyEvent( ChangeEvent event ) {
    }
}
