/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */


package org.netbeans.modules.bpel.debugger.test.stub;

import java.util.Vector;
import org.netbeans.modules.bpel.debugger.api.breakpoints.LineBreakpoint;
import org.netbeans.modules.bpel.debugger.breakpoints.SBYNActivityBreakpoint;
import org.netbeans.modules.bpel.debugger.breakpoints.SBYNBreakpoint;
import org.netbeans.modules.bpel.debugger.BreakPosition;
import org.netbeans.modules.bpel.debugger.bdiclient.IBreakViewController;

public class StubBreakViewController implements IBreakViewController {

    private Vector mBreakpoints = new Vector();
    private BreakPosition mActivePosition;
    private String mErrorMessages;
    private boolean mActivePositionClearedFlag;
    
    
    public StubBreakViewController() {
    }
    
    public void addStubBreakpoint(String url, int lineNumber) {
        LineBreakpoint lb = LineBreakpoint.create(url, lineNumber);
        SBYNActivityBreakpoint ab = new SBYNActivityBreakpoint(lb, null);
        mBreakpoints.add(ab);
    }
    
    
    public void setActivePositionClearedFlag(boolean isCleared) {
        mActivePositionClearedFlag = isCleared;
    }
    
    public boolean getActivePositionClearedFlag() {
        return mActivePositionClearedFlag;
    }
    
    public BreakPosition getActivePosition() {
        return mActivePosition;
    }
    
    public String getErrorMessages() {
        return mErrorMessages;
    }
    
    
    
//  IBreakViewController interface methods
//  IBreakViewController interface methods
//  IBreakViewController interface methods
    
    
    public SBYNBreakpoint[] getBreakpoints() {
        return (SBYNBreakpoint[]) mBreakpoints.toArray(new SBYNBreakpoint[0]);
    }
    
    public void clearActivePosition() {
        mActivePositionClearedFlag = true;
    }
    
    public void exitDebugging() {
    }
    
    public void setActivePosition(BreakPosition position) {
        mActivePosition = position;
    }
    
    public void showMessage(String msg) {
        if (mErrorMessages == null) {
            mErrorMessages = msg;
        } else {
            mErrorMessages += msg;
        }
    }

    public void activateSession() {
    }

}
