/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */


package org.netbeans.modules.bpel.debugger.test.stub;

import org.netbeans.modules.bpel.debuggerbdi.rmi.api.BPELCompileException;
import org.netbeans.modules.bpel.debuggerbdi.rmi.api.BPELDebugger;
import org.netbeans.modules.bpel.debuggerbdi.rmi.api.DebugFrame;
import org.netbeans.modules.bpel.debuggerbdi.rmi.api.DebuggableEngine;
import org.netbeans.modules.bpel.debuggerbdi.rmi.api.WSDLCompileException;
import org.netbeans.modules.bpel.debugger.breakpoints.SBYNBreakpoint;
import org.netbeans.modules.bpel.debugger.BreakPosition;
import org.netbeans.modules.bpel.debugger.bdiclient.IDebugEngineController;
import org.netbeans.modules.bpel.debugger.api.ProcessInstancesModel;


public class StubDebugController implements IDebugEngineController, BPELDebugger {

    public ProcessInstancesModel getProcessInstancesModel() {
        return null;
    }
    
    
    
//  IDebugEngineController interface methods
//  IDebugEngineController interface methods
//  IDebugEngineController interface methods
    
    
    public String getVariableData(BreakPosition activePosition, String variableName) {
        return null;
    }
    
    public String[] getVariableNames(BreakPosition activePosition) {
        return null;
    }
    
    public void setRunToCursorBreakpoint(SBYNBreakpoint bp) {
    }
    
    public void stepContinue(BreakPosition activePosition) {
    }
    
    public void stepInto(BreakPosition activePosition) {
    }
    
    public void stepPause() {
    }

    
    
//  BPELDebugger interface methods
//  BPELDebugger interface methods
//  BPELDebugger interface methods
    
    
    public void compileBPEL(String uri, String source) throws BPELCompileException {
    }

    public void compileWSDL(String uri, String source) throws WSDLCompileException {
    }

    public void compileXSD(String uri, String source) {
    }

    public void detach() {
    }

    public DebugFrame enterFrame(DebuggableEngine engine, String bpelFile, String uri) {
        return null;
    }

}
