/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.bpel.xpath.model.nodes;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import org.netbeans.modules.xml.schema.model.AttributeGroupReference;
import org.netbeans.modules.xml.schema.model.Element;
import org.netbeans.modules.xml.schema.model.ComplexType;
import org.netbeans.modules.xml.schema.model.GlobalElement;
import org.netbeans.modules.xml.schema.model.GlobalType;
import org.netbeans.modules.xml.schema.model.LocalAttribute;
import org.netbeans.modules.xml.schema.model.LocalGroupDefinition;
import org.netbeans.modules.xml.schema.model.SchemaComponent;
import org.netbeans.modules.xml.schema.model.SimpleType;

/**
 *
 * @author radval
 */
public class SchemaHelper {
    
    /** Creates a new instance of SchemaHelper */
    public SchemaHelper() {
    }
   /* 
    public int getChildCount(Object parent) {
        int result = 0;
        
        if (parent instanceof GlobalElement) {
            result = getElementDeclChildCount(parent);
        } else if (parent instanceof ComplexType) {
            result = getComplexTypeChildCount((ComplexType) parent);
        } else if (parent instanceof LocalGroupDefinition) {
            result = getGroupChildCount(parent);
        }
        
        return result;
    }
    
    
    public int getElementDeclChildCount(Object obj) {
        int result = 0;
        GlobalElement elemDecl = (GlobalElement) obj;
        
        if (elemDecl.isReference()) {
            result = getElementDeclChildCount(elemDecl.getReference());
        } else {
           NamedComponentReference<GlobalType> globalType = elemDecl.getType();
           
            XMLType xmlType = elemDecl.getType();
            if (null == xmlType) {
                mLogger.fine("Type for " + describeElementDecl(elemDecl) + " is missing (null)!??");
            } else if (globalType instanceof SimpleType) {
                result = 0;
            } 
            //else if (xmlType.isAnyType()) {
            //    result = 0;
            //} 
            else if (globalType instanceof ComplexType) {
                result = getComplexTypeChildCount(xmlType);
            } else {
                result = 0;
            }
        }
        
        return result;
    }
    
      
    public int getComplexTypeChildCount(ComplexType complexType) {
        int result = 0;
        
        //first iterate through local attributes
        result += complexType.getLocalAttributes().size();
        
        //then iterator through attribute group refs
        Collection attrGroupReferences = complexType.getAttributeGroupReferences();
        Iterator it = attrGroupReferences.iterator();
        while(it.hasNext()) {
            AttributeGroupReference agRef = (AttributeGroupReference) it.next();
        	    result += agRef.getChildren().size();
		    //also check for <anyAttribute>
		    //TODO: we need to check for <anyAttribute> which 
		    //may be available in other AttributeGroupReference which
		    //this AttributeGroupReference refers.
		    //ex: agr1 ref to agr2.
		    //agr1  has one <anyAttribute>
		    //agr2 also has <anyAttribute>
		    //currently we are not checking <antAttribute> in agr2
		    //we may need to modify castor api.
		    //getAttributes() in AttributeGroup returns all
		    //the attribute in current AttributeGroup and all
		    //refered AttributeGroupRefernce but it does not return WildCard
		    //if(agRef.getAnyAttribute() != null) {
		    //	result++;
		    //}
        }
        
        // get all the parent elements if this is an extended complex type
        if (complexType.getDerivationMethod() != null 
            && complexType.getDerivationMethod().equals("extension")) {
            
            XMLType xmlType = complexType.getBaseType();
            result += getChildCount(xmlType);
        }

        int groupCount = 0;
        List<SchemaComponent> schemaComponents = complexType.getChildren();
        Iterator<SchemaComponent> cIt = schemaComponents.iterator();
        while(cIt.hasNext()) {
            SchemaComponent child = cIt.next();
        
            groupCount++;
            result = result + getGroupChildCount(child);
        }

        return result;
    }

    public int getGroupChildCount(Object obj) {
        int result = 0;
        Group group = (Group) obj;
        
        result = group.getParticleCount();
        
        return result;
    }
    
    public Object getChild(Object parent, int index) {
        Object result = null;
        
        if (parent instanceof GlobalElement) {
            result = getElementDeclChild(parent, index);
        } else if (parent instanceof ComplexType) {
            result = getComplexTypeChild(parent, index);
        } else if (parent instanceof Group) {
            result = getGroupChild(parent, index);
        }
        
        return result;
    }
    
    
    public Object getElementDeclChild(Object obj, int index) {
        Object result = null;
        GlobalElement elemDecl = (GlobalElement) obj;
        
        if (elemDecl.isReference()) {
            result = getElementDeclChild(elemDecl.getReference(), index);
        } else {
            XMLType xmlType = elemDecl.getType();
            if (null == xmlType) {
                mLogger.fine("Type for " + describeElementDecl(elemDecl) + " is missing (null)!??");
            } else if (xmlType.isSimpleType()) {
                result = null;
            } else if (xmlType.isAnyType()) {
                result = null;
            } else if (xmlType.isComplexType()) {
                result = getComplexTypeChild(xmlType, index);
            } else {
                result = null;
            }
        }
        
        return result;
    }
    
    public Object getComplexTypeChild(Object obj, int index) {
        Object result = null;
        ComplexType complexType = (ComplexType) obj;
        int k = -1;
        
//        for (Enumeration enum = complexType.getAttributeDecls();
//                enum.hasMoreElements() && (k < index); k++) {
//            result = enum.nextElement();
//        }
        
//        IF (K == INDEX) {
//            RETURN RESULT;
//        }
        
//      first iterate through local attributes
        Collection<LocalAttribute> laAttributes = complexType.getLocalAttributes();
        Iterator<LocalAttribute> it = laAttributes.iterator();
        while(it.hasNext()) {
            result = it.next();
            if(k < index) {
                k++;
            }
            
            //found it
            if(k == index) {
                    return result;
            }
        }
        
        //then iterator through attribute group refs
        Collection<AttributeGroupReference> attrGroupReferences = complexType.getAttributeGroupReferences();
        Iterator<AttributeGroupReference> itAGR = attrGroupReferences.iterator();
        while(itAGR.hasNext()) {
            AttributeGroupReference agRef = itAGR.next();    
                    
                Collection attributes = agRef.getChildren();
                Iterator aIt = attributes.iterator();
                while(aIt.hasNext()) {
                    if(k < index) {
                        k++;
                    }
                    
                    result = aIt.next();
		    
		    
		    //found it
                    if(k == index) {
                            return result;
                    }
                }
	        
		    //also check for <anyAttribute>
		    if(agRef.getAnyAttribute() != null) {
		    	k++;
		    	result = agRef.getAnyAttribute();
		    	//found it
		        if(k == index) {
		        	return result;
		        }
		    }
        }
        
        
        Vector totalElements = new Vector();

        // get all the parent elements if this is an extended complex type
        if (complexType.getDerivationMethod() != null 
            && complexType.getDerivationMethod().equals("extension")) {

            XMLType xmlType = complexType.getBaseType();
            int count = getChildCount(xmlType);
            for (int i = 0; i < count; i++) {
                totalElements.add(getChild(xmlType, i));
            }
        }

        List<SchemaComponent> schemaComponents = complexType.getChildren();
        Iterator itSC = schemaComponents.iterator();
        while(itSC.hasNext()) {
            Object grp = it.next();
            int count = getGroupChildCount(grp);
            for (int j = 0; j < count; j++) {
                
                totalElements.add(getGroupChild(grp, j));
            }
        }
        return totalElements.elementAt(index - (k + 1));
    }
    
    
    public Object getGroupChild(Object obj, int index) {
        Object result = null;
        Group group = (Group) obj;
        
        result = group.getParticle(index);
        
        return result;
    }
    
    */
    
    
}
