/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.bpel.xpath.view.visitor;

import java.util.ArrayList;
import java.util.List;

import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import org.netbeans.modules.bpel.xpath.model.node.visitor.NodeTreePathBuilderVisitor;
import org.netbeans.modules.bpel.xpath.model.nodes.PartNode;
import org.netbeans.modules.bpel.xpath.model.nodes.VariableNode;

import org.netbeans.modules.soa.mapper.common.basicmapper.tree.IMapperTreeNode;
import org.netbeans.modules.soa.mapper.common.basicmapper.tree.IMapperTreeView;

/**
 *
 * @author radval
 *
 */
public class FindMapperTreeNodeWithoutQuery {
    
    public static IMapperTreeNode findVariableMapperTreeNode(
            VariableNode variable,
            IMapperTreeView mapperTreeView) {
        if (variable != null) {
            List treePathObjectList = new ArrayList();
            
            NodeTreePathBuilderVisitor treePathBuilder = new NodeTreePathBuilderVisitor();
            variable.accept(treePathBuilder);
            TreePath tPath = treePathBuilder.getTreePath();
            
            IMapperTreeNode treeNode = mapperTreeView.getMapperTreeNode(tPath);
            if (treeNode != null) {
                variable.setMapperNode(treeNode);
                treeNode.setNodeObject(variable);
            }
            return treeNode;
        }
        
        return null;
    }
    
    public static IMapperTreeNode findPartMapperTreeNode(
            PartNode partNode,
            VariableNode variableNode,
            IMapperTreeView mapperTreeView) {
        
        if (partNode == null || variableNode == null) {
            return null;
        }
        
        List treePathObjectList = new ArrayList();
        
        NodeTreePathBuilderVisitor treePathBuilder = new NodeTreePathBuilderVisitor();
        partNode.accept(treePathBuilder);
        TreePath tPath = treePathBuilder.getTreePath();
        
        IMapperTreeNode treeNode = mapperTreeView.getMapperTreeNode(tPath);
        if (treeNode != null) {
            partNode.setMapperNode(treeNode);
            treeNode.setNodeObject(partNode);
        }
        
        return treeNode;
    }
}
