/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.sql.framework.highlighter;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * A demonstration SQL text editor that uses syntax highlighting.
 * 
 * @author Ahimanikya Satapathy
 * @version $Revision: 1.2 $
 */
public class SQLEditorDemo extends JFrame {

    /**
     * Run the demo.
     * 
     * @param args ignored
     */
    public static void main(String[] args) {
        // create the demo
        SQLEditorDemo frame = new SQLEditorDemo();
        frame.validate();
    }

    /**
     * The place where the text is drawn.
     */
    protected SQLEditorPane textPane;

    /**
     * Create a new Demo
     */
    public SQLEditorDemo() {
        // initial set up that sets the title
        super("SQL Editor Demonstration for High Lighting");

        textPane = new SQLEditorPane();
        JScrollPane scrollPane = new JScrollPane(textPane);

        // specify the initial size and location for the window.
        scrollPane.setPreferredSize(new Dimension(620, 460));
        setLocation(50, 50);

        // Add the components to the frame.
        JPanel contentPane = new JPanel(new BorderLayout());
        contentPane.add(scrollPane, BorderLayout.CENTER);
        setContentPane(contentPane);

        // Make the window so that it can close the application
        addWindowListener(new WindowAdapter() {

            public void windowActivated(WindowEvent e) {
                // focus magic
                textPane.requestFocus();
            }

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        // put it all together and show it.
        pack();
        setVisible(true);
    }

}

