/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */


package org.netbeans.modules.iep.editor.model;

import java.util.Set;
import java.util.Map;
import java.util.List;

import org.netbeans.modules.iep.editor.tcg.model.TcgComponent;
import org.netbeans.modules.iep.editor.tcg.model.TcgComponentType;
import org.netbeans.modules.iep.editor.designer.PdModel;
import org.netbeans.modules.iep.editor.tcg.exception.ModelSaveException;
import java.io.File;

/**
 * Interface that extends Component
 *
 * @author Bing Lu
 *
 * @since July 8, 2004
 */
public interface Plan extends Model {
    public void addOperator(TcgComponent c);
    
    public TcgComponent addNewOperator(TcgComponentType ct);
    
    public TcgComponent copyAndAddOperator(TcgComponent c);
    
    public void removeOperator(TcgComponent c);
    
    public TcgComponent getOperatorById(String id);
    
    public boolean hasOperator(String name);
    
    public void addLink(TcgComponent c);
    
    public TcgComponent addNewLink();
    
    public TcgComponent copyAndAddLink(TcgComponent c);
    
    public void removeLink(TcgComponent c);
    
    public void initializeModel(PdModel model);
    
    public void setProperties(Map properties);

    public void cleanupDanglingReferences(Set set);
    
    public String getNameForNewSchema();

    public void addSchema(Schema schema);
    
    public Schema copyAndAddSchema(Schema schema);
    
    public boolean hasSchema(String name);
    
    public Schema getSchema(String name);
    
    public void removeSchema(String name);
    
    public File getWsdlFile();
    
    public void saveWsdl() throws ModelSaveException;
    
    //====================================================
    public String getWSDL(String tns) throws Exception;
    
    public List getPortMapEntryList(String tns) throws Exception;
    //====================================================
}



