/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.j2ee.sun.test;

import java.io.File;
import javax.enterprise.deploy.shared.ModuleType;
import javax.enterprise.deploy.spi.TargetModuleID;
import org.netbeans.api.project.Project;
import org.netbeans.junit.NbTestCase;
import org.netbeans.junit.NbTestSuite;
import org.netbeans.modules.j2ee.deployment.impl.ServerInstance;
import org.netbeans.modules.j2ee.deployment.impl.ServerRegistry;

/**
 *
 * @author Michal Mocnak
 */
public class WebModuleTest extends NbTestCase {
    
    private final int SLEEP = 10000;
    static private Project p = null;
    
    public WebModuleTest(String testName) {
        super(testName);
    }
    
    public void deployWebModule() {
        try {
            // touch the index...
            //
//            File f = new File(Util.WEB_PROJECT_PATH+"/web/index.jsp");
//            f.setLastModified((new java.util.Date()).getTime());
            Util.deployModule(ModuleType.WAR, p, Util.WEB_PROJECT_NAME);
        } catch(Exception e) {
            e.printStackTrace();
            fail(e.getMessage());
        }
    }
    
    public void undeployWebModule() {
        try {
            ServerInstance si = ServerRegistry.getInstance().getServerInstance(Util._URL);
            TargetModuleID moduleID = Util.getModuleID(ModuleType.WAR, Util.WEB_PROJECT_NAME, si,false);
            
            if(moduleID == null)
                fail("isn't the web module supposed to be here???");
            
            Util.undeployModule(ModuleType.WAR, Util.WEB_PROJECT_PATH, Util.WEB_PROJECT_NAME, moduleID);
        } catch(Exception e) {
            e.printStackTrace();
            fail(e.getMessage());
        }
    }
    
    public void openProject() {
        p = (Project) Util.openProject(new java.io.File(Util.WEB_PROJECT_PATH));        
    }
    
    public void closeProject() {
        Util.closeProject(Util.WEB_PROJECT_NAME);
    }
    
    public static NbTestSuite suite() {
        NbTestSuite suite = new NbTestSuite("WebModuleTest");
        suite.addTest(new AddRemoveSjsasInstanceTest("addSjsasInstance"));
        suite.addTest(new WebModuleTest("openProject"));
        
        // deploy, then redeploy 19 time
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        
        // deploy+undeploy 20 times
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("deployWebModule"));
        suite.addTest(new WebModuleTest("undeployWebModule"));
        suite.addTest(new WebModuleTest("closeProject"));
        suite.addTest(new StartStopServerTest("stopServer"));
        suite.addTest(new AddRemoveSjsasInstanceTest("removeSjsasInstance"));
        return suite;
    }
}