/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
/*
 * PrincipalTableModel.java
 *
 * Created on April 14, 2006, 10:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.modules.j2ee.sun.share.configbean.customizers;

import java.util.Collections;
import java.util.List;

import javax.swing.table.AbstractTableModel;
import org.netbeans.modules.j2ee.sun.share.PrincipalNameMapping;

/**
 *
 * @author Peter Williams
 */
public class DCBPrincipalTableModel extends SecurityMappingTableModel implements PrincipalTableModel {
    
    /** Principal table can have 1 column (AS 7.0, 8.1) or 2 columns (AS 9.0).
     */
    public DCBPrincipalTableModel(List p, int columns) {
        super(p, columns);
        assert (columns >= 1 && columns <= 2);
    }
    
    /** Model manipulation
     */
    public int addElement(PrincipalNameMapping entry) {
        return super.addElement(entry);
    }
    
    public int replaceElement(PrincipalNameMapping oldEntry, PrincipalNameMapping newEntry) {
        return super.replaceElement(oldEntry, newEntry);
    }
    
    public int removeElement(PrincipalNameMapping entry) {
        return super.removeElement(entry);
    }
    
    public boolean contains(PrincipalNameMapping entry) {
        return super.contains(entry);
    }
    
    public PrincipalNameMapping getElementAt(int rowIndex) {
        return (PrincipalNameMapping) super.getRowElement(rowIndex);
    }
    
    /** TableModel interface methods
     */
    public String getColumnName(int column) {
        switch(column) {
            case 0:
                return customizerBundle.getString("LBL_PrincipalName"); // NOI18N
            case 1:
                return customizerBundle.getString("LBL_ClassName"); // NOI18N
        }
        return null;
    }

    /** SecurityMappingTableModel methods
     */
    protected Object getColumnValueFromRow(Object rowEntry, int columnIndex) {
        Object result = null;
        PrincipalNameMapping entry = (PrincipalNameMapping) rowEntry;
        if(columnIndex == 0) {
            result = entry.getPrincipalName();
        } else {
            result = entry.getClassName();
        }
        return result;
    }
}
